-- Players:
	-- 0 [H]:	Condor Legion, Italy
	-- 1 [AI]:	Spain (Nationalists)
p_ES=1
	-- 2 [AI]:	Spanish Republic
p_SR=2

-- 2 Objectives defined in scenario:
	-- 0 		Capture Malaga					(24;6)
	-- 1 opt	Capture 7 other victory hexes	(5;2)(14;4)(3;6)(6;11)(18;12)(13;19)(3;20)

-- 1 Triggers defined in scenario:
	-- 1x	OnObjective1(ObjectiveStatusAction)

-- Use lib. prefix for utility and support functions:
lib = require "shared"	-- file shared.lua in campaign directory ../AO0Spain

-- ** called automatically **
function OnMapStart()
	local value = campaign.comm_points or 0
	campaign.comm_points = lib.InitCommendationPoints(value)	-- UI: Commendation Points
MessageBox("OnMapStart()")	-- DEBUG: find hook for UpdateHeroes()
end

----------------------------------------------------------------
-- Objective 1: Capture all other Victory Hexes before Malaga --
----------------------------------------------------------------

-- ** 1x Effect(ObjectiveStatusAction) **
function OnObjective1(action)
	if (action.side == 0 and action.objective == 1 and action.status == ObjectiveStatus.Success) then
		local comm = 1
		campaign.comm_points = lib.UpdateCommendationPoints(comm)
		MessageBox(string.format(tostring(NSLOCTEXT("scenario_Malaga","earned_cp_format","Bonus Objective to capture all Victory Hexes completed.\nEarned Commendation Points: %d.\nTotal Commendation Points: %d.")), comm, campaign.comm_points))
	end
end

----------------------
-- Ally AI commands --
----------------------

function AllyAttack()
	MessageBox("","Spanish Nationalist units will attack the nearest hostile victory hex.")
	lib.AllySetOrder(p_ES, "AIOrderAttacker")
end

function AllyDefend()
	MessageBox("","Spanish Nationalist units will defend the nearest friendly victory hex.")
	lib.AllySetOrder(p_ES, "AIOrderDefender")
end

function AllyHoldPosition()
	MessageBox("","Spanish Nationalist units will hold position where they are.")
	lib.AllySetOrder(p_ES, "AIOrderHoldPositionFire")
end
