-- Players:
	-- 0 [H]:	Condor Legion, Italy
	-- 1 [AI]:	Spain (Nationalists)
p_ES=1
	-- 2 [AI]:	Spanish Republic
p_SR=2

-- 2 Objectives defined in scenario:
	-- 0 		Capture all victory hexes	{{9,8},{11,20},{12,10},{13,6},{16,14},{17,19},{22,10},{28,13},{29,10}}
	-- 1 opt	Capture 4 mtn victory hexes	(9;3)(17;5)(21;8)(24;10)

-- 2 Triggers defined in scenario:
	-- 1x	EnemyHero(NewRoundAction)
	-- 1x	OnObjective1(ObjectiveStatusAction)

-- Use lib. prefix for utility and support functions:
lib = require "shared"	-- file shared.lua in campaign directory ../AO0Spain

-- ** called automatically **
function OnMapStart()
	local value = campaign.comm_points or 0
	campaign.comm_points = lib.InitCommendationPoints(value)	-- UI: Commendation Points
end

--------------
-- Triggers --
--------------

------------------
-- Enemy heroes --
------------------

enemy_heroes = {
	-- @NOTE: name not provided (pick up from unit.name, if any)
	{unit_id=90, traits={UnitTrait.IncMaxOverstrength, UnitTrait.TenaciousDefender}}	-- rcn "Nino Nanetti" W Bilbao, per scenario
}

-- ** 1x Effect(NewRoundAction) **
-- Creates enemy Hero(es)
function EnemyHero()
	lib.CreateAndAssignHeroes(p_SR, enemy_heroes)
MessageBox("EnemyHero()")	-- DEBUG: find hook to UpgradeHeroes()
end

-----------------------------------------------------------------------------
-- Objective 1: Capture all mountain positions before the last Victory Hex --
-----------------------------------------------------------------------------

-- ** 1x Effect(ObjectiveStatusAction) **
function OnObjective1(action)
	if (action.side == 0 and action.objective == 1 and action.status == ObjectiveStatus.Success) then
		local comm = 1
		campaign.comm_points = lib.UpdateCommendationPoints(comm)
		MessageBox(string.format(tostring(NSLOCTEXT("scenario_Bilbao","earned_cp_format","Bonus Objective to capture all Secondary Hexes completed.\nEarned Commendation Points: %d.\nTotal Commendation Points: %d.")), comm, campaign.comm_points))
	end
end

----------------------
-- Ally AI commands --
----------------------

function AllyAttack()
	MessageBox("","Spanish Nationalist units will attack the nearest hostile victory hex.")
	lib.AllySetOrder(p_ES, "AIOrderAttacker")
end

function AllyDefend()
	MessageBox("","Spanish Nationalist units will defend the nearest friendly victory hex.")
	lib.AllySetOrder(p_ES, "AIOrderDefender")
end

function AllyHoldPosition()
	MessageBox("","Spanish Nationalist units will hold position where they are.")
	lib.AllySetOrder(p_ES, "AIOrderHoldPositionFire")
end
