-- Players:
	-- 0 [H]:	Condor Legion, Italy
	-- 1 [AI]:	Spain (Nationalists)
p_ES=1
	-- 2 [AI]:	Spanish Republic
p_SR=2

-- 2 Objectives defined in scenario:
	-- 0 		Capture Gijon									(5;6)
	-- 1 opt	Capture all other Victory Hexes before Gijon	(18;6)(22;8)(13;13)(16;13)(21;13)(28;14)(17;19)(22;20)(26;20)(4;21)

-- 3 Triggers defined in scenario:
	-- 1x	EnemyHero(NewRoundAction)
	-- 1x	OnObjective1(ObjectiveStatusAction)
	-- 1x	PrestigeSink(NewRoundAction)

-- Use lib. prefix for utility and support functions:
lib = require "shared"	-- file shared.lua in campaign directory ../AO0Spain

-- ** called automatically **
function OnMapStart()
	local value = campaign.comm_points or 0
	campaign.comm_points = lib.InitCommendationPoints(value)	-- UI: Commendation Points
end

-------------------
-- Prestige Sink --
-------------------

-- ** 1x Effect(NewRoundAction) **
function PrestigeSink()
	local message = string.format(tostring(NSLOCTEXT("scenario_Gijon","difficult_choice","Mein General, request coming in from our Nationalist allies.  The war has disrupted many civil services across Spain, and there is a severe lack of qualified workers to repair complex systems.  As a result they've asked if we can spare some of our maintenance crews to assist in rebuilding civilian infrastructure.  I estimate the amount of support they've requested will halve our resources, so we should not make this decision lightly.  If we do help them though, it should dramatically increase our influence in the future.\n\nYou have %d Commendation Points.\n\nWould you like to exchange HALF of your total prestige for 12 Commendation Points?")), campaign.comm_points)
	local choose_action = world:MakeChooseAction(0, message, "ProcessChoice")
	choose_action.options = {
		{
			title  = NSLOCTEXT("scenario_Gijon","option1","Authorize the exchange"),
			tooltip= NSLOCTEXT("scenario_Gijon","option1_tooltip","")
		},
		{
			title  = NSLOCTEXT("scenario_Gijon","option2","Decline the exchange"),
			tooltip= NSLOCTEXT("scenario_Gijon","option2_tooltip","")
		}
	}
	world:Exec(choose_action)	-- "ProcessChoice" ==> ProcessChoice(player,choice)
end

function ProcessChoice(player, choice)
	if (choice == 1) then		-- The player chose option 1, which is "yes"
		local comm = 12
		campaign.comm_points = lib.UpdateCommendationPoints(comm)

		local p = world:GetPlayer(player)
		p.prestige = math.ceil(p.prestige / 2)  -- remove 50% of prestige
		-- p.prestige = p.prestige * 70 / 100 -- remove 30% of prestige
	end
	local choice_made =
	{
		NSLOCTEXT("scenario_Gijon","choice_made1","You choose to assist, offering half of your existing supplies.  You now have %d Commendation Points."),
		NSLOCTEXT("scenario_Gijon","choice_made2","You choose to reject the offer.  You still have %d Commendation Points"),
	}
	MessageBox(string.format(tostring(choice_made[choice]), campaign.comm_points))
MessageBox("ProcessChoice()")	-- DEBUG: find hook to UpgradeHeroes()
end

------------------
-- Enemy heroes --
------------------

enemy_heroes = {
	-- @NOTE: name not provided (pick up from unit.name, if any)
	{unit_id=17, traits={UnitTrait.DoubleSupport}},	-- art in Sierra de Cuera, per scenario
	{unit_id=43, traits={UnitTrait.DoubleSupport}} 	-- aa/at in Sierra de Cuera, per scenario
}

-- ** 1x Effect(NewRoundAction) **
-- Creates enemy Hero(es)
function EnemyHero()
	lib.CreateAndAssignHeroes(p_SR, enemy_heroes)
MessageBox("EnemyHero()")	-- DEBUG: find hook for UpgradeGeroes()
end

---------------------------------------------------------------
-- Objective 1: Capture all other Victory Hexes before Gijon --
---------------------------------------------------------------

-- ** 1x OnObjective1(ObjectiveStatusAction) **
function OnObjective1(action)
	if (action.side == 0 and action.objective == 1 and action.status == ObjectiveStatus.Success) then
		local comm = 1
		campaign.comm_points = lib.UpdateCommendationPoints(comm)
		MessageBox(string.format(tostring(NSLOCTEXT("scenario_Gijon","earned_cp_format","Bonus Objective to capture all Victory Hexes completed.\nEarned Commendation Points: %d.\nTotal Commendation Points: %d.")), comm, campaign.comm_points))
	end
end

----------------------
-- Ally AI commands --
----------------------

function AllyAttack()
	MessageBox("","Spanish Nationalist units will attack the nearest hostile victory hex.")
	lib.AllySetOrder(p_ES, "AIOrderAttacker")
end

function AllyDefend()
	MessageBox("","Spanish Nationalist units will defend the nearest friendly victory hex.")
	lib.AllySetOrder(p_ES, "AIOrderDefender")
end

function AllyHoldPosition()
	MessageBox("","Spanish Nationalist units will hold position where they are.")
	lib.AllySetOrder(p_ES, "AIOrderHoldPositionFire")
end
