-- Players:
	-- 0 [H]:	Germany
	-- 1 [AI]:	Poland
p_PO=1
	-- 2 [AI]:	USSR
p_RU=2

-- 1 Objective defined in scenario:
	-- 0 		Capture all victory hexes

-- 1 Trigger defined in scenario:
	-- 1x	PrestigeSink(NewRoundAction)

-- Use lib. prefix for utility and support functions:
lib = require "shared"	-- file shared.lua in campaign directory ../AO1939

-- ** called automatically **
function OnMapStart()
	local value = campaign.comm_points or 0
	campaign.comm_points = lib.InitCommendationPoints(value)	-- UI: Commendation Points
end

--------------
-- Triggers --
--------------

-------------------
-- Prestige Sink --
-------------------

-- ** 1x Effect(NewRoundAction) **
function PrestigeSink()
	local message = string.format(tostring(NSLOCTEXT("scenario_Wlodawa","difficult_choice","Mein General, I am afraid I have terrible news.  Operational Group E sent some of their goons to inspect our operations, and they are furious at our lack of detainment of Polish civilians.  They say if we do not turn over all of our combat POWs and civilian captives immediately to OGE custody, they have threatened to take the matter up with High Command.  At the very least, we can expect the following investigation to seriously impact our supply situation.\n\nFor what it is worth, the men are highly resentful of OGE directives, and are ready to report that all of our Polish captives mysteriously escaped into the night... if I give the word.\n\nWill you risk losing 75 PERCENT of your total prestige for 14 Commendation Points?  Or will you bow to OGE directives to avoid penalty?")), campaign.comm_points)
	local choose_action = world:MakeChooseAction(0, message, "ProcessChoice")
	choose_action.options = {
		{
			title  = NSLOCTEXT("scenario_Wlodawa","option1","Refuse OGE directives"),
			tooltip= NSLOCTEXT("scenario_Wlodawa","option1_tooltip","WARNING this action will cost you 75 percent of your total prestige")
		},
		{
			title  = NSLOCTEXT("scenario_Wlodawa","option2","Give in to demands"),
			tooltip= NSLOCTEXT("scenario_Wlodawa","option2_tooltip","No lasting consequences")
		}
	}
	world:Exec(choose_action)	-- "ProcessChoice" ==> ProcessChoice(player,choice)
end

function ProcessChoice(player, choice)
	if (choice == 1) then		-- The player chose option 1, which is "yes"
		local comm = 14
		campaign.comm_points = lib.UpdateCommendationPoints(comm)

		local p = world:GetPlayer(player)
		p.prestige = math.ceil(p.prestige / 4)  -- remove 75% of prestige
	end
	local choice_made =
	{
		NSLOCTEXT("scenario_Wlodawa","choice_made1","You choose to defy Operational Group E directives, ultimately costing you more than half of your existing supplies.  You now have %d Commendation Points."),
		NSLOCTEXT("scenario_Wlodawa","choice_made2","You choose avoid a confrontation and give in to their demands.  You still have %d Commendation Points"),
	}
	MessageBox(string.format(tostring(choice_made[choice]), campaign.comm_points))
end
