-- Players:
	-- 0 [H]:	Germany
	-- 1 [AI]:	USSR
p_RU=1
	-- 2 [AI]:	MCP "Main Combat Patrol"
p_MCP=2

-- 2 Objectives defined in scenario:
	-- 0 		Destroy 16 units	unit IDs 0,1,2,4,11,12,14,15,16,17,18,19,21,22,24,25,27,28,29,30,31,32,33
	-- 1 opt	Destroy 7 units		unit IDs 3,5,6,7,8,9,10 of "Main Combat Patrol" (all have Heroes)

-- 2 Triggers defined in scenario:
	-- 1x	EnemyHero(NewRoundAction)
	-- 1x	OnObjective1(ObjectiveStatusAction)	{if Objective1Condition()}

-- Use lib. prefix for utility and support functions:
lib = require "shared"	-- file shared.lua in campaign directory ../AO1939

-- ** called automatically **
function OnMapStart()
	local value = campaign.comm_points or 0
	campaign.comm_points = lib.InitCommendationPoints(value)	-- UI: Commendation Points
end

--------------
-- Triggers --
--------------

------------------
-- Enemy heroes --
------------------

enemy_heroes = {
	-- @NOTE: name not provided (pick up from unit.name, if any)
	{unit_id= 3, traits={UnitTrait.PhasedMovement}},	-- tank "Main Combat Patrol", per scenario
	{unit_id= 5, traits={UnitTrait.ArtySupport}},		-- tank "Main Combat Patrol", per scenario
	{unit_id= 6, traits={UnitTrait.NoRetaliation}},		-- tank "Main Combat Patrol", per scenario
	{unit_id= 7, traits={UnitTrait.Unyielding}}, 		-- tank "Main Combat Patrol", per scenario
	{unit_id= 8, traits={UnitTrait.NoRetreat}},			-- tank "Main Combat Patrol", per scenario
	{unit_id= 9, traits={UnitTrait.NoSupply}},			-- rcn  "Main Combat Patrol", per scenario
	{unit_id=10, traits={UnitTrait.FastDeployment}}		-- art  "Main Combat Patrol", per scenario
}

-- ** 1x Effect(NewRoundAction) **
-- Creates enemy Hero(es)
function EnemyHero()
	lib.CreateAndAssignHeroes(p_MCP, enemy_heroes)
end

-----------------------------------------------------
-- Objective 1: Destroy 7 Main Combat Patrol Units --
-----------------------------------------------------

-- ** 1x Effect(ObjectiveStatusAction) {if Objective1Condition()} **
function OnObjective1(action)
	local comm = 2
	campaign.comm_points = lib.UpdateCommendationPoints(comm)
	MessageBox(string.format(tostring(NSLOCTEXT("scenario_RaateRoad","earned_cp_format","Bonus Objective to eliminate Main Combat Patrol completed.\nEarned Commendation Points: %d.\nTotal Commendation Points: %d.")), comm, campaign.comm_points))
end

-- ** Condition for OnObjective1() **
function Objective1Condition(action)
	return action.side == 0 and action.objective == 1 and action.status == ObjectiveStatus.Success
end
