-- Players:
	-- 0 [H]:	Germany
	-- 1 [AI]:	USSR
p_RU=1

-- 2 Objectives defined in scenario:
	-- 0 @end	Capture 6 victory hexes		(19;3)(6;4)(15;9)(2;11)(21;13)(6;15)(10;15)(23;15)(15;19)(8;21)
	-- 1 @end	Capture 10 victory hexes	(19;3)(6;4)(15;9)(2;11)(21;13)(6;15)(10;15)(23;15)(15;19)(8;21)

-- 3 Triggers defined in scenario:
	-- 1x	EnemyHero(NewRoundAction)
	-- 1x	OnObjective1(ObjectiveStatusAction)		{if Objective1Condition()}
	-- 		OnNewRound(NewRoundAction)				{if EmptyCondition()}

-- Use lib. prefix for utility and support functions:
lib = require "shared"	-- file shared.lua in campaign directory ../AO1939

-- ** called automatically **
function OnMapStart()
	local value = campaign.comm_points or 0
	campaign.comm_points = lib.InitCommendationPoints(value)	-- UI: Commendation Points
end

-------------------
-- Key Locations --
-------------------

VHs = {{25,7},{23,13},{6,18},{25,24},{14,26},{24,26}}

-- Spawn zones
-- When spawning a set of units, the script will scan spawn zones hex by hex, in the order specified, and spawn units in free hexes it finds
-- If the script runs out of hexes, the remainder of the units will not be spawned.
-- There can be any number of zones in this list, the game will pick a random one every time
zones = {
	{{27,20},{28,20},{26,21},{26,22},{25,23},{25,24},{24,25},{24,26}},	-- SE
	{{14,26},{15,26},{16,26},{17,26},{13,27},{17,27},{13,28},{18,28}},	-- S
	{{1,26},{2,26},{3,26},{4,26},{5,26},{4,27},{5,27},{6,28}}				-- SW
}

--------------
-- Triggers --
--------------

------------------
-- Enemy heroes --
------------------

enemy_heroes = {
	-- @NOTE: name not provided (pick up from unit.name, if any)
	{unit_id=63, traits={UnitTrait.DoubleAttack}}	-- ftr "Bronislav Myshkin" in S camp, per scenario
}

-- ** 1x Effect(NewRoundAction) **
-- Creates enemy Hero(es)
function EnemyHero()
	lib.CreateAndAssignHeroes(p_RU, enemy_heroes)
end

----------------------
-- Enemy unit waves --
----------------------

normal_wave_turns = {5,10,15,16,20}

-- Each unit set is a list of blocks in the following format: {"<Unit ID>","<Transport ID>", overstrength, experience}
-- If no organic transport is needed, its respective field should be empty string ("").
-- There can be any number of waves in this list, the game will pick a random one every time
waves = {
	{{"Conscript","",5,0},{"Conscript","",5,0},{"Conscript","",5,0},{"Conscript","",5,0},{"45mmM1937","HorseTransport",0,900},{"PolikarpovI16","",2,900}},
	{{"SUEngineers","HorseTransport",2,900},{"Regular","HorseTransport",0,900},{"Regular","HorseTransport",0,900},{"T26","",1,900},{"76mmM1939","HorseTransport",2,900},{"37mmM1939AA","HorseTransport",0,900},{"PolikarpovI16","",2,900}},
	{{"SUEngineers","HorseTransport",2,900},{"Regular","HorseTransport",0,900},{"Regular","HorseTransport",0,900},{"T26","",1,900},{"76mmM1939","HorseTransport",2,900},{"37mmM1939AA","HorseTransport",0,900},{"PolikarpovI16","",2,900}},
	{{"SUHWInf","HorseTransport",2,900},{"Regular","HorseTransport",0,900},{"GazAAMG-AA","",1,900},{"76mmM1939","HorseTransport",2,900},{"AT1","",0,900},{"BT7","",0,900},{"PolikarpovI16","",2,900}},
	{{"AT1","",0,900},{"T26","",0,900},{"T26","",0,900},{"T28","",5,1900},{"BA10","",0,900},{"BA10","",0,900},{"PolikarpovI16","",2,900}}
}

-- ** Condition for OnNewRound() **
-- Not needed, but ** used in scenario **
function EmptyCondition()
	return true
end

-- ** Effect(NewRoundAction) {if EmptyCondition()} **
-- Spawns enemy units
function OnNewRound(action)
	-- On the first call, initialize the random generator
	if (world.round == 1) then math.randomseed(world.seed) end

	-- If we don't need to spawn any wave this turn then just finish
	if (not lib.IsItemInTable(normal_wave_turns, world.round)) then return end

	lib.SpawnWave(p_RU, zones[math.random(#zones)], waves[math.random(#waves)])
end

--------------------------------------------
-- Objective 1: Control All Victory Hexes --
--------------------------------------------

-- ** Condition for OnObjective1() **
function Objective1Condition(action)
	return action.side == 0 and action.objective == 1 and action.status == ObjectiveStatus.Success
end

-- ** checked at scenario end **
-- ** 1x Effect(ObjectiveStatusAction) {if Objective1Condition()} **
function OnObjective1(action)
	local comm = 2
	campaign.comm_points = lib.UpdateCommendationPoints(comm)
	MessageBox(string.format(tostring(NSLOCTEXT("scenario_Taipale","earned_cp_format","Bonus Objective to control all Victory Hexes completed.\nEarned Commendation Points: %d.\nTotal Commendation Points: %d.")), comm, campaign.comm_points))
end
