-- Players:
	-- [H]:	Germany
	-- [AI]:	Denmark
p_DK=1

-- 2 Objectives defined in scenario:
	-- 0 		Capture 7 victory hexes		(13;20)(21;22)(9;23)(2;25)(16;28)(17;32)(21;33)
	-- 1 		Destroy 2 units				unit IDs 23,24 hangers in Vaerlose and Alborg, per scenario

-- 1 Triggers defined in scenario:
	-- 1x	OnStart(NewRoundAction)

-- Use lib. prefix for utility and support functions:
lib = require "shared"	-- file shared.lua in campaign directory ../AO1939

-- ** called automatically **
function OnMapStart()
	local value = campaign.comm_points or 0
	campaign.comm_points = lib.InitCommendationPoints(value)	-- UI: Commendation Points
end

--------------
-- Triggers --
--------------

----------------------
-- CP for equipment --
----------------------

trade = {
	cps = 5,
	eqs = {{"KV2TNK",35}}
}

-- ** 1x Effect(NewRoundAction) **
function OnStart()
	if (campaign.comm_points < trade.cps) then return end

	local message = string.format(tostring(NSLOCTEXT("scenario_Denmark","difficult_choice2","Mein General, I have just been informed of an interesting trade agreement between Germany and Finland.  Apparently, the Finns recently sold us quite a stockpile of Soviet wrecks which are headed for Kummersdorf for analysis.\n\nSome of our mechanics mananaged to review the inventory when it arrived at Kiel, and they tell me that some of the wrecks are not beyond repair.  In fact, there is a particular bunker busting monstrosity they insist we procure for ourselves.\n\nUsing some of your influence, I am certain we could get a portion of the salvage rerouted to our own stockpiles.\n\nYou have %d Commendation Points.\n\nWould you like to use 5 Commendation Points acquire special Soviet salvage?")), campaign.comm_points)
	local choose_action = world:MakeChooseAction(0, message, "ProcessChoice")
	choose_action.options = {
		{
			title  = NSLOCTEXT("scenario_Denmark","option1","Authorize the exchange"),
			tooltip= NSLOCTEXT("scenario_Denmark","option1_tooltip","")
		},
		{
			title  = NSLOCTEXT("scenario_Denmark","option2","Decline the exchange"),
			tooltip= NSLOCTEXT("scenario_Denmark","option2_tooltip","")
		}
	}
	world:Exec(choose_action)	-- "ProcessChoice" ==> ProcessChoice(player,choice)
end

function ProcessChoice(player, choice)
	if (choice == 1) then		-- The player chose option 1, which is "yes"
		local comm = 0 - trade.cps	-- make negative
		campaign.comm_points = lib.UpdateCommendationPoints(comm)
		lib.AddEquipments(player, trade.eqs, Captured)
	end
	local choice_made =
	{
		NSLOCTEXT("scenario_Denmark","choice_made1","You choose to accept the offer.  You now have %d Commendation Points."),
		NSLOCTEXT("scenario_Denmark","choice_made2","You choose to reject the offer.  You still have %d Commendation Points"),
	}
	MessageBox(string.format(tostring(choice_made[choice]), campaign.comm_points))
end
