-- 1st scenario in campaign (need to generate extra heroes)
-- Players:
	-- 0 [H]:	Germany
	-- 1 [AI]:	Norway
p_NO=1

-- 3 Objectives defined in scenario:
	-- 0 @end	Capture 3 victory hexes		(6;5)(13;7)(3;12)(5;18)(6;28)
	-- 1 opt	Capture all victory hexes	""
	-- 2 opt	Guard 3 units				unit IDs 64,65,66,80

-- 8 Triggers defined in scenario:
	-- 1x	OnStartGame(NewRoundAction)
	-- 1x	PlayerHero(NewRoundAction)
	-- 1x	EnemyHero(NewRoundAction)
	-- 		OnObjective1(ObjectiveStatusAction)		{if Objective1Condition}
	-- 		OnObjective2(ObjectiveStatusAction)		{if Objective2Conditon}
	-- 		OnCaptureStoreHouse(CaptureFlagAction)
	-- KMS Blcher:
	-- 1x	Bsurvive(DeathAction|SurrenderAction)	{if Fortstatus}
	-- 1x	Effect2(DeathAction|SurrenderAction)	{if Condition2}

-- Use lib. prefix for utility and support functions:
lib = require "shared"	-- file shared.lua in campaign directory ../AO1940

-- ** called automatically **
function OnMapStart()
	local value = campaign.comm_points or 0
	campaign.comm_points = lib.InitCommendationPoints(value)	-- UI: Commendation Points
end

-------------------
-- Key Locations --
-------------------

cache = {
	loc = {{19,36}},	-- Oscarsborg Fortress, per Scenario
	eqs = {{"Wurfrahmen40",30}}
}

-- This table is initially empty, and will accumulate depots which we capture
-- Depots won't generate a bonus if we lose them and recapture for the second time
captured_depots = {}

--------------
-- Triggers --
--------------

------------------
-- Enemy heroes --
------------------

enemy_heroes = {
	-- @NOTE: name not provided (pick up from unit.name, if any)
	{unit_id=77, traits={UnitTrait.LowProfile}},	-- tank in Oslo, per scenario
	{unit_id=87, traits={UnitTrait.QuadripleGun}}	-- bmr NW of deployment, per scenario
}

-- ** 1x Effect(NewRoundAction) **
-- Creates enemy Hero(es)
function EnemyHero()
	lib.CreateAndAssignHeroes(p_NO, enemy_heroes)
end

---------------------
-- Player Hero(es) --
---------------------

-- @NOTE: these are repeated at start of AO1941 campaign -
player_heroes = {
	-- the Units with these IDs exist only when _not_ importing Core units into campaign
	-- repeats from 1939/Czechoslovakia:
	{unit_id=51, name=NSLOCTEXT("scenario_Fornebu","Volkhardt_Kautz","Volkhardt Kautz"), portrait="/Game/Gui/Common/Heroes/DE/de_in_11.de_in_11", traits={UnitTrait.QuadripleGun}}, -- Bf 110C
	{unit_id=59, name=NSLOCTEXT("scenario_Fornebu","Markus_von_Reuenthal","Markus von Reuenthal"), portrait="/Game/Gui/Common/Heroes/DE/de_in_02.de_in_02", traits={UnitTrait.Scavenger}}, -- Panzer 35(t)
	{unit_id=40, name=NSLOCTEXT("scenario_Fornebu","Siegfried_von_Bonde","Siegfried von Bonde"), portrait="/Game/Gui/Common/Heroes/DE/de_af_07.de_af_07", traits={UnitTrait.ArtySupport,UnitTrait.ATSupport}}, -- Panzer IIIB
	{unit_id=37, name=NSLOCTEXT("scenario_Fornebu","Reinhardt_Herzog","Reinhardt Herzog"), portrait="/Game/Gui/Common/Heroes/DE/de_af_13.de_af_13", traits={UnitTrait.StrikesFirst,UnitTrait.PhasedMovement}}, -- Pioniere
	{unit_id=48, name=NSLOCTEXT("scenario_Fornebu","Wolfgang_Schneider","Wolfgang Schneider"), portrait="/Game/Gui/Common/Heroes/DE/de_af_14.de_af_14", traits={UnitTrait.ZeroSlots}}, -- 15 cm sFH 18
	{unit_id=42, name=NSLOCTEXT("scenario_Fornebu","Ludwig_Mittermeier","Ludwig Mittermeier"), portrait="/Game/Gui/Common/Heroes/DE/de_in_13.de_in_13", traits={UnitTrait.Evasive,UnitTrait.Liberator}}, -- SdKfz 231 6Rad
	-- new:
	{unit_id=52, name=NSLOCTEXT("scenario_Fornebu","Diederich_Franzen","Diederich Franzen"), portrait="/Game/Gui/Common/Heroes/DE/de_af_01.de_af_01", traits={UnitTrait.LightningAttack}}, -- Ju 87B
	{unit_id=56, name=NSLOCTEXT("scenario_Fornebu","Ingvar_Dugross","Ingvar Dugross"), portrait="/Game/Gui/Common/Heroes/DE/de_af_02.de_af_02", traits={UnitTrait.DoubleMove}},  -- He 111H2
	-- repeat from SCW/Battle of the Ebro:
	{unit_id=54, name=NSLOCTEXT("scenario_Fornebu","Adolf_Galland","Adolf Galland"), portrait="/Game/Gui/Common/Heroes/DE_AF_galland.DE_AF_galland", traits={UnitTrait.Legendary,UnitTrait.Leadership,UnitTrait.AimingAssistance}, unit_classes={UnitClass.Fighter,UnitClass.TacticalBomber}}
}

-- ** 1x Effect(NewRoundAction) **
function PlayerHero()
	lib.CreateAndAssignHeroes(0, player_heroes)
end

------------------------
-- Messages to player --
------------------------

-- ** 1x Effect(NewRoundAction) **
function OnStartGame()
	MessageBox(string.format(tostring(NSLOCTEXT("scenario_Fornebu","current_cp_format2","In this campaign, you can earn Commendation Points by completing bonus objectives. Opportunities to exchange Commendation Points for various rewards will be offered as the campaign progresses.\n\nYou begin this campaign with %d Commendation Points.")), campaign.comm_points))
end

--------------------------------------------
-- Objective 1: Capture all victory hexes --
--------------------------------------------

-- ** Effect(ObjectiveStatusAction) {if Objective1Condition()} **
function OnObjective1(action)
	local comm = 1
	campaign.comm_points = lib.UpdateCommendationPoints(comm)
	MessageBox(string.format(tostring(NSLOCTEXT("scenario_Fornebu","earned_cp_format","Bonus Objective to capture all Victory Hexes completed.\nEarned Commendation Points: %d.\nTotal Commendation Points: %d.")), comm, campaign.comm_points))
end

-- ** Condition for OnObjective1() **
function Objective1Condition(action)
	return action.side == 0 and action.objective == 1 and action.status == ObjectiveStatus.Success
end

------------------------------------------------------
-- Objective 2: Protect at least 3 Grounded BF 110s --
------------------------------------------------------

-- ** Effect(ObjectiveStatusAction) {if Objective2Condition()} **
function OnObjective2(action)
	local comm = 3
	campaign.comm_points = lib.UpdateCommendationPoints(comm)
	MessageBox(string.format(tostring(NSLOCTEXT("scenario_Fornebu","earned_cp_format2","Bonus Objective to protect grounded BF 110s units completed.\nEarned Commendation Points: %d.\nTotal Commendation Points: %d.")), comm, campaign.comm_points))
end

-- ** Condition for OnObjective2() **
function Objective2Condition(action)
	return action.side == 0 and action.objective == 2 and action.status == ObjectiveStatus.Success
end

---------------------
-- Equipment cache --
---------------------

-- ** Effect(CaptureFlagAction) **
function OnCaptureStoreHouse(action)
	-- If this flag was not captured by Axis side, do nothing
	if (world:GetPlayer(action.new_owner).side_id ~= 0) then return end

	-- Don't generate reward if the same depot is captured for the second time
	if (lib.IsItemInTable(captured_depots, action.flag)) then return end

	-- Remember that this depot has been captured
	table.insert(captured_depots, action.flag)

	if (lib.IsItemInTable(cache.loc, action.flag)) then
		lib.AddEquipments(0, cache.eqs, Prototypes)
		TutorialMessage(NSLOCTEXT("scenario_Fornebu","string_C","<bi>Hauptmann Wagner: </>Mein General, our capture of the Oscarsborg Fortress has taken High Command quite by surprise.  As reward for avenging the Blucher, they have arranged a delivery of some experimental rocket artillery.  We can purchase them as prototype equipment."))
	end
end

-----------------
-- KMS Blcher --
-----------------

-- KMS Blcher is unit ID #0, per scenario
-- Oscarsborg Fortress is unit ID #6, per scenario
-- Destroying the fort ==> ship survives

-- ** Condition for Bsurvive() **
function Fortstatus()
	return world:GetUnit(6) == nil	-- Oscarsborg Fortress destroyed
end

-- ** Effect(DeathAction|SurrenderAction) {if Fortstatus()} **
function Bsurvive(action)
	-- see: AO1940/script.lua for initial definition of campaign.blucher
	if (campaign.blucher == true) then
		TutorialMessage(NSLOCTEXT("scenario_Fornebu","string_bfleet","<bi>KRIEGSMARINE COMMUNIQUE: </>\n\n\nHeavy Cruiser Blucher no longer taking fire from shore batteries.\nDamage control efforts underway, counterflooding is righting the ship.\nTo the pilots who saved our ship: a thousand thanks.\n\n-Admiral Kummetz"))
	end
end

-- ** Condition for Effect2() **
function Condition2()
	return world:GetUnit(0) == nil	-- Blcher destroyed
end

-- ** Effect(DeathAction|SurrenderAction) {if Condition2()} **
function Effect2()
	if (campaign.blucher == true) then
		campaign.blucher = false	-- flag for Brighton scenario
		TutorialMessage(NSLOCTEXT("scenario_Fornebu","string_bdeath","<bi>Hauptmann Wagner: </>Mein General, I am sorry to report that KMS Blucher has slipped beneath the waves."))
	end
end
