-- Players:
	-- 0 [H]:	Germany
	-- 1 [AI]:	Bohemia (Germany)
p_DE=1

-- 1 Objective defined in scenario:
	-- 0 		Hold victory hex	(23;13)

-- 4 Triggers defined in scenario:
	-- 1x	OnStartGame(NewRoundAction)
	-- 1x	Turn1(NewRoundAction)	{if IsFirstTurn()}
	-- 1x	Turn3(NewRoundAction)	{if IsthirdTurn()}
	-- 1x	Kloss(NewRoundAction)	{if IsFourthTurn()}

-- Use lib. prefix for utility and support functions:
lib = require "shared"	-- file shared.lua in campaign directory ../AO1940

-- ** called automatically **
function OnMapStart()
	local value = campaign.comm_points or 0
	campaign.comm_points = lib.InitCommendationPoints(value)	-- UI: Commendation Points
end

-------------------
-- Key Locations --
-------------------

--------------
-- Triggers --
--------------

------------------------
-- Messages to player --
------------------------

-- ** 1x Effect(NewRoundAction) **
function OnStartGame()
	TutorialMessage(NSLOCTEXT("scenario_UndisclosedLocationCZ","string_Proto","<bi>Hauptmann Wagner: </>Mein Herr, check it out!  New prototypes are being prepped for launch over near Dresden!"))
end

-- ** Condition for Turn1() **
function IsFirstTurn()
	return world.round == 1
end

-- ** 1x Effect(NewRoundAction) {if IsFirstRound()} **
function Turn1()
	TutorialMessage(NSLOCTEXT("scenario_UndisclosedLocationCZ","string_Proto2","<bi>Hauptmann Wagner: </>Ohh...  They blew up...  Well I guess it's back to the drawing board with those designs."))
end

-- Rudel, turn 3

-- ** Condition for Turn3() **
function IsthirdTurn()
	return world.round == 3
end

-- ** 1x Effect(NewRoundAction) {if IsthirdTurn()} **
function Turn3()
	TutorialMessage(NSLOCTEXT("scenario_UndisclosedLocationCZ","string_rudelcz","<bi>Flight Adjutant Rudel: </>I apologize for the unexpected intrusion, but I must have your ear for just one moment, Herr General.  I know your training exercises here are supposed to be a secret, and that I probably shouldn't have snuck out of Vienna to come, so let's keep this conversation between just you and I, ja?\n\nI'm convinced your dog Wagner has been eating my repeated applications for a combat transfer, so I am here to make my case to you in person.  Let us forget about politics and paperwork and speak truthfully.\n\nI can no longer stand being a flying photographer, nor will I be content sit on the sidelines of this great conflict.  I am here to fulfill my duty to fight for Germany.  I ask no more than any other soldier who fights for their homeland, and I will accept no less.  I humbly request a proper chance to prove myself in combat and to serve my country.  Remember this, the next time my application crosses your desk.\n\nI bid you good luck on your secret mission, Herr General."))
end

---------------------
-- Player Hero(es) --
---------------------

-- ** Condition for Kloss() **
function IsFourthTurn()
	return world.round == 4
end

-- ** 1x Effect(StartTurnAction) {if IsFourthTurn()} **
function Kloss()
	if (campaign.comm_points < 3) then return end

	local message = string.format(tostring(NSLOCTEXT("scenario_UndisclosedLocationCZ","difficult_choice","Mein General, as part of the expansion of the war effort, a somewhat controversial proposal has been put forward.  To ease some demand for manpower, it has been proposed that Germany expand the Wehrmachthelferinnen.  Our female auxiliaries would begin to be deployed to supporting units, mostly air defense and artillery detachments.\n\nI do not know how you feel about this inclusion of women, but my personal experiences in Spain have shown me that female soldiers of merit are a force to be reckoned with.\n\nIf you choose to throw your support behind this new initiative, High Command will undoubtedly use us to test the feasibility of female auxiliaries before deciding whether or not to expand the program further.\n\nYou have %d Commendation Points.\n\nWould you like to exchange 3 Commendation Points for a unique female officer?")), campaign.comm_points)
	local choose_action = world:MakeChooseAction(0, message, "ProcessChoice")
	choose_action.options = {
		{
			title  = NSLOCTEXT("scenario_UndisclosedLocationCZ","option1","Authorize the exchange"),
			tooltip= NSLOCTEXT("scenario_UndisclosedLocationCZ","option1_tooltip","")
		},
		{
			title  = NSLOCTEXT("scenario_UndisclosedLocationCZ","option2","Decline the exchange"),
			tooltip= NSLOCTEXT("scenario_UndisclosedLocationCZ","option2_tooltip","")
		}
	}
	world:Exec(choose_action)	-- "ProcessChoice" ==> ProcessChoice(player,choice)
end

function ProcessChoice(player, choice)
	if (choice == 1) then		-- The player chose option 1, which is "yes"
		local comm = -3
		campaign.comm_points = lib.UpdateCommendationPoints(comm)
		CreateKloss()
	end
	local choice_made =
	{
		NSLOCTEXT("scenario_UndisclosedLocationCZ","choice_made1","You decide to use some of your influence and accept the offer.  You now have %d Commendation Points."),
		NSLOCTEXT("scenario_UndisclosedLocationCZ","choice_made2","You choose to reject the offer.  You still have %d Commendation Points"),
	}
	MessageBox(string.format(tostring(choice_made[choice]), campaign.comm_points))
end

kloss_hero = {
	{
		name=NSLOCTEXT("scenario_UndisclosedLocationCZ","Elsa_Kloss","Elsa Kloss"),
		portrait="/Game/Gui/Common/Heroes/de_in_kloss.de_in_kloss",
		modifiers={{type=Ammo,mod=3},{type=Range,mod=1}},
		unit_classes={UnitClass.Artillery}	--,UnitClass.AntiTank,UnitClass.AntiAir}
	}
}

function CreateKloss()
	lib.CreateAndAssignHeroes(0,kloss_hero)
end

