-- Players:
	-- 0 [H]:	Germany
	-- 1 [AI]:	Netherlands, Belgium
p_BE=1
p_NL=p_BE

-- 3 Objectives defined in scenario:
	-- 0 @end	Capture 1 victory hex	(11;12)
	-- 1 opt	Capture 2 victory hexes	(9;3)(12;3)
	-- 2 opt	Capture 2 victory hexes	(7;21)(9;22)

-- 3 Triggers defined in scenario:
	-- 1x	EnemyHero(NewRoundAction)
	-- 1x	OnObjective1(ObjectiveStatusAction)	{if Objective1Status()}
	-- 1x	OnObjective2(ObjectiveStatusAction)	{if Objective2Status()}

-- Use lib. prefix for utility and support functions:
lib = require "shared"	-- file shared.lua in campaign directory ../AO1940

-- ** called automatically **
function OnMapStart()
	local value = campaign.comm_points or 0
	campaign.comm_points = lib.InitCommendationPoints(value)	-- UI: Commendation Points
end

--------------
-- Triggers --
--------------

------------------
-- Enemy heroes --
------------------

enemy_heroes = {
	-- @NOTE: name not provided (pick up from unit.name, if any)
	{unit_id=26, traits={UnitTrait.NoRetaliation}},			-- tank NW of Wintershoven, per scenario
	{unit_id=28, traits={UnitTrait.OverwhelmingAttack}},	-- inf SW of Wintershoven, per scenario
	{unit_id=58, traits={UnitTrait.IncMaxOverstrength}} 	-- inf SW of Tongeren, per scenario
}

-- ** 1x Effect(NewRoundAction) **
-- Creates enemy Hero(es)
function EnemyHero()
	lib.CreateAndAssignHeroes(p_BE, enemy_heroes)
end

-------------------------------------
-- Objective 1: Capture Maastricht --
-------------------------------------

-- ** 1x Effect(ObjectiveStatusAction) {if Objective1Condition()} **
function OnObjective1(action)
	local comm = 1
	campaign.comm_points = lib.UpdateCommendationPoints(comm)
	MessageBox(string.format(tostring(NSLOCTEXT("scenario_EbenEmael","earned_cp_format","Bonus Objective to Capture Maastricht completed.\nEarned Commendation Points: %d.\nTotal Commendation Points: %d.")), comm, campaign.comm_points))
end

-- ** Condition for OnObjective1() **
function Objective1Condition(action)
	return action.side == 0 and action.objective == 1 and action.status == ObjectiveStatus.Success
end

--------------------------------
-- Objective 2: Capture Liege --
--------------------------------

-- ** 1x Effect(ObjectiveStatusAction) {if Objective2Condition()} **
function OnObjective2(action)
	local comm = 1
	campaign.comm_points = lib.UpdateCommendationPoints(comm)
	MessageBox(string.format(tostring(NSLOCTEXT("scenario_EbenEmael","earned_cp_format2","Bonus Objective to Capture Liege completed.\nEarned Commendation Points: %d.\nTotal Commendation Points: %d.")), comm, campaign.comm_points))
end

-- ** Condition for OnObjective2() **
function Objective2Condition(action)
	return action.side == 0 and action.objective == 2 and action.status == ObjectiveStatus.Success
end
