-- Players:
	-- 0 [H]:	Germany
	-- 1 [AI]:	France
p_FR=1

-- 3 Objectives defined in scenario:
	-- 0 		Capture all victory hexes	(Leave Troyes for last)
	-- 1 opt	Destroy 1 unit			unit ID 50 (20pt Char 2C "Champagne")
	-- 2 opt	Capture 2 victory hexes	(23;30)(22;31)

-- 4 Triggers defined in scenario:
	-- 1x	EnemyHero(NewRoundAction)
	-- 1x	OnObjective1(ObjectiveStatusAction)	{if Objective1Status()}
	-- 1x	OnObjective2(ObjectiveStatusAction)	{if Objective2Status()}
	-- 1x	Char2C(CaptureFlagAction)			{if CharCheck()}

-- Use lib. prefix for utility and support functions:
lib = require "shared"	-- file shared.lua in campaign directory ../AO1940

-- ** called automatically **
function OnMapStart()
	local value = campaign.comm_points or 0
	campaign.comm_points = lib.InitCommendationPoints(value)	-- UI: Commendation Points
end

--------------
-- Triggers --
--------------

------------------
-- Enemy heroes --
------------------

enemy_heroes = {
	-- @NOTE: name not provided (pick up from unit.name, if any)
	{unit_id=38, traits={UnitTrait.Camouflage}},	-- rcn SE of Chlons-en-Champagne, per scenario
	{unit_id=19, traits={UnitTrait.DoubleAttack}},	-- art NW of Neufchateaux, per scenario
	{unit_id=25, traits={UnitTrait.NoEntrenchment, UnitTrait.MachineGun}},	-- inf NE Troyes, per scenario
	{unit_id=50, traits={UnitTrait.NoManagement}}	-- tank "Champagne" (Char 2C) W of Neufchateaux, per scenario
}

-------------
-- Nemesis --
-------------

nem_unit=51	-- de Gaulle is unit ID #51, per scenario
-- @TODO:
-- Nemesis eliminated

enemy_nemesis = {
	-- @NOTE: name not provided (pick up from unit.name, if any)
	{unit_id=nem_unit, traits={UnitTrait.NoRetreat}, portrait = "/Game/Gui/Common/Heroes/fr_in_degaulle.fr_in_degaulle"}	-- tank "Charles de Gaulle" (Nemesis) NW of Neufchateaux, per scenario
}

-- ** 1x Effect(NewRoundAction) **
-- Creates enemy Hero(es)
function EnemyHero()
	lib.CreateAndAssignHeroes(1, enemy_heroes)
--  see: AO1940/script.lua for initial definition of campaign.nemesislives
	if (campaign.nemesislives == true) then
		lib.CreateAndAssignHeroes(p_FR, enemy_nemesis)	-- de Gaulle
	else
		world:Exec(world:MakeDeathAction(world:GetUnit(nem_unit)))	-- Nemesis unit eliminated previously, remove from scenario
	end
end

-------------------
-- Char 2C tanks --
-------------------

eqs = {{"Char2C",35}}
uniquetankA = false
uniquetankB = false

-----------------------------------------------------------------------
-- Objective 1: Engage Unknown French Detachment before Troyes falls --
-----------------------------------------------------------------------
-- Destroy unit ID 50 (20pt Char 2C "Champagne")

-- ** Condition for OnObjective1() **
function Objective1Condition(action)
	return action.side == 0 and action.objective == 1 and action.status == ObjectiveStatus.Success
end

-- ** 1x Effect(ObjectiveStatusAction) {if Objective1Condition()} **
function OnObjective1(action)
	MessageBox(NSLOCTEXT("scenario_Neufchateau","str1","Bonus Objective to disable French Char 2C completed.  Special Commendation Point acquired."))
	uniquetankA = true

-- @TODO: Nemesis eliminated
	-- added here until better hook established (scenario change):
	if (world:GetUnit(nem_unit) == nil and campaign.nemesislives == true) then campaign.nemesislives = false end
end

----------------------------------------------------------
-- Objective 2: Capture Neufchateau before Troyes falls --
----------------------------------------------------------

-- ** Condition for OnObjective2() **
function Objective2Condition(action)
	return action.side == 0 and action.objective == 2 and action.status == ObjectiveStatus.Success
end

-- ** 1x Effect(ObjectiveStatusAction) {if Objective2Condition()} **
function OnObjective2(action)
	MessageBox(NSLOCTEXT("scenario_Neufchateau","str2","Bonus Objective to Capture Neufchateau completed.  Special Commendation Point acquired."))
	uniquetankB = true

-- @TODO: Nemesis eliminated
	-- added here until better hook established (scenario change):
	if (world:GetUnit(nem_unit) == nil and campaign.nemesislives == true) then campaign.nemesislives = false end
end

-- ** Condition for Char2C() **
function CharCheck()
	return uniquetankA == true and uniquetankB == true
end

-- ** Effect(CaptureFlagAction) {if CharCheck()}  **
function Char2C(action)
	TutorialMessage(NSLOCTEXT("scenario_Neufchateau","string_sco1","<bi>Hauptmann Wagner: </>Report coming in from the front for your immediate attention.  With that monstrous French tank disabled and Neufchateau secure, our salvage teams have completed a preliminary inspection of the area.  The nearby rail station was found to be well stocked with the specialized equipment necessary to maintain that behemoth of a tank."))
	TutorialMessage(NSLOCTEXT("scenario_Neufchateau","string_sco2","<bi>Hauptmann Wagner: </>From what we recovered on the field and pillaged from the rail station, we have enough materials to potentially field the Char 2C tank for ourselves!"), false)
	TutorialMessage(NSLOCTEXT("scenario_Neufchateau","string_sco3","<bi>Hauptmann Wagner: </>The salvage is now accessable as captured equipment."), false)
	lib.AddEquipments(0, eqs, Captured)
end
