-- Players:
	-- 0 [H]:	Germany
	-- 1 [AI]:	UK - Practice Targets
p_UK=1

-- 1 Objective defined in scenario:
	-- 0 @end	Capture 1 victory hex	(1;20)	-- already owned

-- 1 Trigger defined in scenario:
	-- 		OnCaptureStoreHouse(CaptureFlagAction)

-- Use lib. prefix for utility and support functions:
lib = require "shared"	-- file shared.lua in campaign directory ../AO1940

-- ** called automatically **
function OnMapStart()
	local value = campaign.comm_points or 0
	campaign.comm_points = lib.InitCommendationPoints(value)	-- UI: Commendation Points
end

-------------------
-- Key Locations --
-------------------

cache = {
	loc = {{8,5}},	-- Lovasz Residence, per scenario
	eqs = {{"SpitfireMkII",9},{"HurricaneMkIIC",25}}
}

-- This table is initially empty, and will accumulate depots which we capture
-- Depots won't generate a bonus if we lose them and recapture for the second time
captured_depots = {}

--------------
-- Triggers --
--------------

---------------------
-- Equipment cache --
---------------------

-- ** Effect(CaptureFlagAction) **
function OnCaptureStoreHouse(action)
	-- If this flag was not captured by Axis side, do nothing
	if (world:GetPlayer(action.new_owner).side_id ~= 0) then return end

	-- Don't generate reward if the same depot is captured for the second time
	if (lib.IsItemInTable(captured_depots, action.flag)) then return end

	-- Remember that this depot has been captured
	table.insert(captured_depots, action.flag)

	if (lib.IsItemInTable(cache.loc, action.flag)) then
		TutorialMessage(NSLOCTEXT("scenario_ChannelIslandsTraining","string_sco1","<bi>Hauptmann Wagner: </>Mein General, I followed up on a tip from a British defector that there might be something of value on the island.  Apparently the Standard Island Preferred Shipping Corporation was unable to move all the Allied equipment from the island before our arrival, so they tried to bury one of their warehouses."))
		TutorialMessage(NSLOCTEXT("scenario_ChannelIslandsTraining","string_sco2","<bi>Hauptmann Wagner: </>After digging up a ridiculous amount of dirt, we finally found the warehouse.  Some of the Spitfires were damaged by falling dirt, so we didn't recover enough of them to form a squadron, not yet at least.  We did find a bunch of strange looking Hurricane fighters though.  They have some powerful cannons, but it looks like that heavy weaponry has taken quite a toll on their flight performance.  After we clean all the dirt off, we can access these fighters as captured units."), false)
		lib.AddEquipments(0, cache.eqs, Captured)
	end
end
