-- Players:
	-- 0 [H]:	Germany
	-- 1 [AI]:	Greece
p_GR=1

-- 3 Objectives defined in scenario:
	-- 0 @end	Capture 3 victory hexes	(3;3)(23;7)(6;9)(12;14)(4;24)
	-- 1 opt	Capture 1 victory hex	(27;26)	-- Metsovo
	-- 2 opt	Destroy 5 units			unit IDs 22,23,24,25,26	-- Commanders

-- 3 Triggers defined in scenario:
	-- 1x	EnemyHero(NewRoundAction)
	-- 1x	OnObjective1(ObjectiveStatusAction)	{if Objective1Status()}
	-- 1x	OnObjective2(ObjectiveStatusAction)	{if Objective2Status()}

-- Use lib. prefix for utility and support functions:
lib = require "shared"	-- file shared.lua in campaign directory ../AO1940

-- ** called automatically **
function OnMapStart()
	local value = campaign.comm_points or 0
	campaign.comm_points = lib.InitCommendationPoints(value)	-- UI: Commendation Points
end

--------------
-- Triggers --
--------------

------------------
-- Enemy Heroes --
------------------

enemy_heroes = {
	-- @NOTE: name not provided (pick up from unit.name, if any)
	{unit_id=22, traits={UnitTrait.PreciseOptics, UnitTrait.MachineGun}},	-- art "Commander Konstantinopolites" E of Kalpaki, per scenario
	{unit_id=23, traits={UnitTrait.NoRetaliation}},			-- inf mtn "Commander Dougenis" ENE of Konitsa, per scenario
	{unit_id=24, traits={UnitTrait.IgnoresEntrenchment}},	-- inf mtn "Commander Adamos" NW of Metsovo, per scenario
	{unit_id=25, traits={UnitTrait.OverwhelmingAttack}},	-- cav "Commander Eliopoulos" ESE of Kalpaki, per scenario
	{unit_id=26, traits={UnitTrait.StrikesFirst}} 			-- cav "Commander Sideris" WNW of Samarina, per scenario
}

-- ** 1x Effect(NewRoundAction) **
-- Creates enemy Hero(es)
function EnemyHero()
	lib.CreateAndAssignHeroes(p_GR, enemy_heroes)
end

-------------------------------
-- Objective 1: Raid Metsovo --
-------------------------------

-- ** Condition for OnObjective1() **
function Objective1Condition(action)
	return action.side == 0 and action.objective == 1 and action.status == ObjectiveStatus.Success
end

-- ** 1x Effect(ObjectiveStatusAction) {if Objective1Condition()} **
function OnObjective1(action)
	local comm = 1
	campaign.comm_points = lib.UpdateCommendationPoints(comm)
	MessageBox(string.format(tostring(NSLOCTEXT("scenario_Pindus","earned_cp_format","Bonus Objective to Raid Metsovo completed.\nEarned Commendation Points: %d.\nTotal Commendation Points: %d.")), comm, campaign.comm_points))
end

-----------------------------------------------
-- Objective 2: Eliminate 5 Greek Commanders --
-----------------------------------------------

-- ** Condition for OnObjective2() **
function Objective2Condition(action)
	return action.side == 0 and action.objective == 2 and action.status == ObjectiveStatus.Success
end

-- ** 1x Effect(ObjectiveStatusAction) {if Objective2Condition()} **
function OnObjective2(action)
	local comm = 1
	campaign.comm_points = lib.UpdateCommendationPoints(comm)
	MessageBox(string.format(tostring(NSLOCTEXT("scenario_Pindus","earned_cp_format2","Bonus Objective to Eliminate 5 Greek Commanders completed.\nEarned Commendation Points: %d.\nTotal Commendation Points: %d.")), comm, campaign.comm_points))
end
