-- 1st scenario in campaign (need to generate extra heroes)
-- Players:
	-- 0 [H]:	Germany
	-- 1 [AI]:	Yugoslavia
p_YU=1
	-- 2 [AI]:	Hungary
p_HU=2

-- 3 Objectives defined in scenario:
	-- 0 @end	Capture 2 victory hexes	(6;27)(9;28)
	-- 1 opt	Guard 1 unit			unit ID 13
	-- 2 opt	Capture 7 victory hexes	(30;18)(33;23)(22;24)(25;24)(28;25)(19;28)(21;31)(25;31)(30;31)

-- 9 Triggers defined in scenario:
	-- 1x	OnStartGame(NewRoundAction)
	-- 1x	PlayerHero(NewRoundAction)
	-- 1x	EnemyHero(NewRoundAction)
	-- 1x	OnObjective(CaptureFlagAction)		{if Zagrebcheck()}			-> OnObjective0()
	-- 1x	OnObjective2(ObjectiveStatusAction)	{if Objective2Conditon()}
	-- 1x	Tolditank(StartTurnAction)			{if Turn2()}
	-- 1x	Silence()							{if Turn3()}
	-- 1x	EncounterAction(MoveAction)			{if EncounterCheck()}
	-- 1x	WagnerBonus(NewRoundAction)			{if Turn25Check()}

-- Use lib. prefix for utility and support functions:
lib = require "shared"	-- file shared.lua in campaign directory ../AO1941East

-- ** called automatically **
function OnMapStart()
	local value = campaign.comm_points or 0
	campaign.comm_points = lib.InitCommendationPoints(value)	-- UI: Commendation Points
end

-------------------
-- Key Locations --
-------------------

VHs = {{6,27},{9,28}}	-- Zagreb, per scenario

--------------
-- Triggers --
--------------

------------------------
-- Messages to player --
------------------------

-- ** 1x Effect(NewRoundAction) **
function OnStartGame()
	local comm = 0
	campaign.comm_points = lib.UpdateCommendationPoints(comm)
	MessageBox(string.format(tostring(NSLOCTEXT("scenario_Zagreb","current_cp_format2","In this campaign, you can earn Commendation Points by completing bonus objectives. Opportunities to exchange Commendation Points for various rewards will be offered as the campaign progresses.\n\nYou begin this campaign with %d Commendation Points.")), campaign.comm_points))
end

------------------
-- Enemy heroes --
------------------

enemy_heroes = {
	-- @NOTE: name not provided (pick up from unit.name, if any)
	{unit_id=67, traits={UnitTrait.AggressiveCounterattack}},				-- cav "Captain Markovic" N Zagreb, per scenario
	{unit_id=71, traits={UnitTrait.OverwhelmingAttack, UnitTrait.Evasive}}	-- cav "Major Knezevic" SE, per scenario
}

-- ** 1x Effect(NewRoundAction) **
-- Creates enemy Hero(es)
function EnemyHero()
	lib.CreateAndAssignHeroes(p_YU, enemy_heroes)
end

---------------------
-- Player Hero(es) --
---------------------

player_heroes = {
	-- the Units with these IDs exist only when _not_ importing Core units into campaign
	-- repeats from 1939/Czechoslovakia:
	{unit_id=25, name=NSLOCTEXT("scenario_Zagreb","Volkhardt_Kautz","Volkhardt Kautz"), portrait="/Game/Gui/Common/Heroes/DE/de_in_11.de_in_11", traits={UnitTrait.QuadripleGun,UnitTrait.Readiness}},	-- ftr bmr
	{unit_id=14, name=NSLOCTEXT("scenario_Zagreb","Markus_von_Reuenthal","Markus von Reuenthal"), portrait="/Game/Gui/Common/Heroes/DE/de_in_02.de_in_02", traits={UnitTrait.Scavenger,UnitTrait.LowProfile}},	-- tank
	{unit_id=16, name=NSLOCTEXT("scenario_Zagreb","Siegfried_von_Bonde","Siegfried von Bonde"), portrait="/Game/Gui/Common/Heroes/DE/de_af_07.de_af_07", traits={UnitTrait.ArtySupport,UnitTrait.ATSupport,UnitTrait.Famous}},	-- tank
	{unit_id=19, name=NSLOCTEXT("scenario_Zagreb","Reinhardt_Herzog","Reinhardt Herzog"), portrait="/Game/Gui/Common/Heroes/DE/de_af_13.de_af_13", traits={UnitTrait.StrikesFirst,UnitTrait.PhasedMovement}},	-- inf eng
	{unit_id=22, name=NSLOCTEXT("scenario_Zagreb","Wolfgang_Schneider","Wolfgang Schneider"), portrait="/Game/Gui/Common/Heroes/DE/de_af_14.de_af_14", traits={UnitTrait.ZeroSlots,UnitTrait.FastDeployment}}, -- art
	{unit_id=17, name=NSLOCTEXT("scenario_Zagreb","Ludwig_Mittermeier","Ludwig Mittermeier"), portrait="/Game/Gui/Common/Heroes/DE/de_in_13.de_in_13", traits={UnitTrait.Evasive,UnitTrait.Liberator}},	-- rcn
	-- repeats from 1940/Fornebu:
	{unit_id=26, name=NSLOCTEXT("scenario_Zagreb","Diederich_Franzen","Diederich Franzen"), portrait="/Game/Gui/Common/Heroes/DE/de_af_01.de_af_01", traits={UnitTrait.LightningAttack}},	-- bmr
	{unit_id=29, name=NSLOCTEXT("scenario_Zagreb","Ingvar_Dugross","Ingvar Dugross"), portrait="/Game/Gui/Common/Heroes/DE/de_af_02.de_af_02", traits={UnitTrait.DoubleMove}}, 	-- bmr
	-- repeats from 1940/UndisclosedLocationCZ:
	{unit_id=21, name=NSLOCTEXT("scenario_Zagreb","Elsa_Kloss","Elsa Kloss"), portrait="/Game/Gui/Common/Heroes/de_in_kloss.de_in_kloss", modifiers={{type=Ammo,mod=3},{type=Range,mod=1}}, unit_classes = {UnitClass.Artillery}},	-- art Kloss
	-- new:
	{unit_id=15, name=NSLOCTEXT("scenario_Zagreb","Friedrich_von_Kraken","Friedrich von Kraken"), portrait="/Game/Gui/Common/Heroes/DE/de_in_04.de_in_04", traits={UnitTrait.ReducedSlots,UnitTrait.IncMaxOverstrength}},	-- tank
	{unit_id=34, name=NSLOCTEXT("scenario_Zagreb","Helmut Kielb","Helmut Kielb"), portrait="/Game/Gui/Common/Heroes/DE/de_af_06.de_af_06", traits={UnitTrait.Prudent,UnitTrait.DoubleSupport}}, 	-- at
	-- repeat from SCW/Battle of the Ebro:
	{unit_id=24, name=NSLOCTEXT("scenario_Zagreb","Adolf_Galland","Adolf Galland"), portrait="/Game/Gui/Common/Heroes/DE_AF_galland.DE_AF_galland", traits={UnitTrait.Legendary,UnitTrait.Leadership,UnitTrait.AimingAssistance}, unit_classes={UnitClass.Fighter,UnitClass.TacticalBomber}}
}

wagner = {
	{unit_id=13, name=NSLOCTEXT("scenario_Zagreb","Stefan_Wagner","Stefan Wagner"), portrait="/Game/Gui/Common/Heroes/de_in_wagner.de_in_wagner", traits={UnitTrait.Leadership,UnitTrait.NoSplit,UnitTrait.ArtySupport}}
}

-- ** 1x Effect(NewRoundAction) **
function PlayerHero()
	lib.CreateAndAssignHeroes(0, player_heroes)
	lib.CreateAndAssignHeroes(0, wagner, true)	-- create silently, without usual Hero pop-up
end

--------------------
-- Gift equipment --
--------------------

eqs = {{"38MToldiI", 30}}

-- ** Condition for Tolditank() **
function Turn2()
	return world.round == 2
end

-- ** 1x Effect(StartTurnAction) {if Turn2()} **
function Tolditank(action)
	lib.AddEquipments(0, eqs, Captured)
	TutorialMessage(NSLOCTEXT("scenario_Zagreb","string_tolditank","<bi>Hauptmann Wagner: </>Message arrived from our quartermasters back in Hungary.  It seems some of the men won a bet against their Hungarian army hosts, and the prize was access to few of their Toldi tanks.  They failed to mention what they offered up as ante, but it's probably best we don't ask.  A few of the Hungarian tanks will be available to us in limited stock."))
end

------------------------
-- Messages to player --
------------------------

-- ** Condition for Silence() **
function Turn3()
	return world.round == 3
end

-- ** 1x Effect(StartTurnAction) {if Turn3()} **
function Silence(action)
	TutorialMessage(NSLOCTEXT("scenario_Zagreb","string_borderguards","<bi>Hauptmann Wagner: </>Mein General, we should have been greeted by Yugoslavian border guards by now; the silence is most unsettling.  I'm going to order our ceremonial detachment to load live ammunition, just in case we need it."))
end

--------------------------------
-- Objective 0: Secure Zagreb --
--------------------------------

-- ** Condition for OnObjective0() **
function Zagrebcheck()
	return lib.CountSide1VHs(VHs) == 2
end

-- ** 1x Effect(CaptureFlagAction) {if Zagrebcheck()} **
function OnObjective0(action)
	TutorialMessage(NSLOCTEXT("scenario_Zagreb","string_search","<bi>Hauptmann Wagner: </>Mein General, our detachment has secured Zagreb, but there is no sign of the Prince or his escorts.  There is a public radio broadcast that seems to be repeating; we'll get it translated shortly."))
	TutorialMessage(NSLOCTEXT("scenario_Zagreb","string_coupradio","<bi>Hauptmann Wagner: </>The radio broadcast is claiming there has been a coup, and that the usurpers have taken Prince Paul and his family into their custody!  Mein General, perhaps there is still a chance we can rescue the Prince.  We should scour the villages to the east in search of him."), false)
	TutorialMessage(NSLOCTEXT("scenario_Zagreb","string_objectiveupdate","<bi>OBJECTIVE UPDATED</>\n\n\nAttempt to locate Prince Paul by capturing Yugoslavian villages to the east."), false)
end

------------------------------------------------------------
-- Objective 2: Rendezvous with Prince Paul of Yugoslavia --
------------------------------------------------------------

-- ** Condition for OnObjective2() **
function Objective2Condition(action)
	return action.side == 0 and action.objective == 2 and action.status == ObjectiveStatus.Success
end

-- ** 1x Effect(ObjectiveStatusAction)	{if Objective2Conditon()} **
function OnObjective2(action)
	local comm = 2
	campaign.comm_points = lib.UpdateCommendationPoints(comm)
	MessageBox(string.format(tostring(NSLOCTEXT("scenario_Zagreb","earned_cp_format2","Bonus Objective to attempt to locate Prince Paul completed.\nEarned Commendation Points: %d.\nTotal Commendation Points: %d.")), comm, campaign.comm_points))
	TutorialMessage(NSLOCTEXT("scenario_Zagreb","string_princepaul","<bi>Hauptmann Wagner: </>Mein General, it is no use.  The organizers of the coup are too far ahead of us, and we've lost the trail on Prince Paul and his family.  We should keep Zagreb secure and then prepare to leave Yugoslavia, before more hostile forces have the chance to trap our small detachment."))
end

-- @TODO: .lib
function GetObjectiveStatus(side, objective)	-- support function: returns enum ObjectiveStatus (.Success|.Fail) of the given side's objective
	return world.sides[side+1].objectives[objective+1].status
end

-- ** Condition for WagnerBonus() **
function Turn25Check()
	return world.round == 25 and GetObjectiveStatus(0,1) ~= ObjectiveStatus.Fail
end

-- ** 1x Effect(NewRoundAction) {if Turn25Check()} **
function WagnerBonus(action)
	local comm = 1
	campaign.comm_points = lib.UpdateCommendationPoints(comm)
	MessageBox(string.format(tostring(NSLOCTEXT("scenario_Zagreb","earned_cp_format","Bonus Objective for Wagner's Halftrack surviving completed.\nEarned Commendation Points: %d.\nTotal Commendation Points: %d.")), comm, campaign.comm_points))
end

-----------------------------------
-- Proximity/Encounter detection --
-----------------------------------

-- ** Condition for EncounterAction() **
function EncounterCheck()
	local filter1 =
	{
		player = 0,
	}
	local filter2 =
	{
		player = p_YU,
		id = {54,55,56,62,63,65,66,67,68,69,64,70}, -- unit IDs of units NE of Zagreb, per scenario
		spotted_by = 0
	}
	return lib.ProximityCheck(filter1, filter2, 2)
end

-- ** 1x Effect(MoveAction) {if EncounterCheck()} **
function EncounterAction()
	TutorialMessage(NSLOCTEXT("scenario_Zagreb","string_ambush","<bi>Hauptmann Wagner: </>Achtung!  Achtung!  Hostile forces have fired upon us, it is an ambush!"))
end
