-- Players:
	-- 0 [H]:	Germany
	-- 1 [AI]:	Yugoslavia
p_YU=1
	-- 2 [AI]:	Fritz
p_Fritz=2

-- 2 Objectives defined in scenario:
	-- 0 		Capture all victory hexes
	-- 1 opt	Capture 1 victory hex	(3;24)	-- Sarajevo

-- 3 Triggers defined in scenario:
	-- 1x	EnemyHero(NewRoundAction)
	-- 1x	OnObjective1(CaptureFlagAction)		{if Objective1Condition()}
	-- 1x	EncounterAction(MoveAction)			{if EncounterCheck()}

-- Use lib. prefix for utility and support functions:
lib = require "shared"	-- file shared.lua in campaign directory ../AO1941East

-- ** called automatically **
function OnMapStart()
	local value = campaign.comm_points or 0
	campaign.comm_points = lib.InitCommendationPoints(value)	-- UI: Commendation Points
end

--------------
-- Triggers --
--------------

------------------
-- Enemy heroes --
------------------

enemy_heroes = {
	-- @NOTE: name not provided (pick up from unit.name, if any)
	{unit_id=60, traits={UnitTrait.IncMaxOverstrength}}, 	-- tank SW Sarajevo, per scenario
	{unit_id=61, traits={UnitTrait.IncMaxOverstrength}} 	-- rcn SW Sarajevo, per scenario
}

-- ** 1x Effect(NewRoundAction) **
-- Creates enemy Hero(es)
function EnemyHero()
	lib.CreateAndAssignHeroes(p_YU, enemy_heroes)
end

-------------------------------------------------------------------------
-- Objective 1: Raid Sarajevo before the final Victory Hex is captured --
-------------------------------------------------------------------------

-- ** 1x Effect(ObjectiveStatusAction) {if Objective1Condition()} **
function OnObjective1(action)
	local comm = 2
	campaign.comm_points = lib.UpdateCommendationPoints(comm)
	MessageBox(string.format(tostring(NSLOCTEXT("scenario_Yugoslavia","earned_cp_format","Bonus Objective to raid Sarajevo completed.\nEarned Commendation Points: %d.\nTotal Commendation Points: %d.")), comm, campaign.comm_points))
end

-- ** Condition for OnObjective1() **
function Objective1Condition(action)
	return action.side == 0 and action.objective == 1 and action.status == ObjectiveStatus.Success
end

-----------------------------------
-- Proximity/Encounter detection --
-----------------------------------

-- ** Condition for EncounterAction() **
function EncounterCheck()
	local filter1 =
	{
		player = 0,
	}
	local filter2 =
	{
		player = p_Fritz,
		id = {0},	-- only unit
		spotted_by = 0
	}
	return lib.ProximityCheck(filter1, filter2, 2)
end

-- ** 1x Effect(MoveAction) {if EncounterCheck()} **
function EncounterAction()
	TutorialMessage(NSLOCTEXT("scenario_Yugoslavia","string_fritz1","<bi>Hauptmann Wagner: </>Mein General, we've received a very curious radio signal from the Yugoslavian capital.  It seems that a small vanguard of Germans are already in the city.  They claim to have successfully negotiated the surrender of the city and its entire garrison!"))
	TutorialMessage(NSLOCTEXT("scenario_Yugoslavia","string_fritz2","<bi>Hauptmann Wagner: </>I advise caution, but if there is truth to their claims, we should be able to roll right through Belgrade and continue our advance well ahead of schedule."), false)
end
