-- Players:
	-- 0 [H]:	Germany
	-- 1 [AI]:	Italy
p_IT=1
	-- 2 [AI]:	Bulgaria
p_BG=2
	-- 3 [AI]:	Greece
p_GR=3
	-- 4 [AI]:	UK
p_UK=4

-- 3 Objectives defined in scenario:
	-- 0 		Capture 1 victory hex	(34;25)	-- Mt. Olympus
	-- 1 opt	Capture 1 victory hex	(45;22)	-- Thessaloniki
	-- 2 opt	Capture 1 victory hex	(14;18)	-- Koritsa

-- 3 Triggers defined in scenario:
	-- 1x	EnemyHero(NewRoundAction)
	-- 1x	OnObjective1(CaptureFlagAction)		{if Objective1Condition()}
	-- 1x	OnObjective2(CaptureFlagAction)		{if Objective2Condition()}

-- Use lib. prefix for utility and support functions:
lib = require "shared"	-- file shared.lua in campaign directory ../AO1941East

-- ** called automatically **
function OnMapStart()
	local value = campaign.comm_points or 0
	campaign.comm_points = lib.InitCommendationPoints(value)	-- UI: Commendation Points
end

--------------
-- Triggers --
--------------

------------------
-- Enemy heroes --
------------------

enemy_heroes = {
	-- @NOTE: name not provided (pick up from unit.name, if any)
	{unit_id=174, traits={UnitTrait.LowProfile, UnitTrait.TenaciousDefender}},		-- tank (Brit.) SW Edessa, per scenario
	{unit_id=175, traits={UnitTrait.AggressiveCounterattack, UnitTrait.Provocator}}	-- tank (Brit.) SW Edessa, per scenario
}

-- ** 1x Effect(NewRoundAction) **
-- Creates enemy Hero(es)
function EnemyHero()
	lib.CreateAndAssignHeroes(p_UK, enemy_heroes)
end

-----------------------------------------------------------------
-- Objective 1: Raid Thessaloniki before capturing Mt. Olympus --
-----------------------------------------------------------------

-- ** Condition for OnObjective1() **
function Objective1Condition(action)
	return action.side == 0 and action.objective == 1 and action.status == ObjectiveStatus.Success
end

-- ** 1x Effect(ObjectiveStatusAction) {if Objective1Condition()} **
function OnObjective1(action)
	local comm = 2
	campaign.comm_points = lib.UpdateCommendationPoints(comm)
	MessageBox(string.format(tostring(NSLOCTEXT("scenario_Thessaloniki","earned_cp_format","Bonus Objective to raid Thessaloniki completed.\nEarned Commendation Points: %d.\nTotal Commendation Points: %d.")), comm, campaign.comm_points))
end

------------------------------------------------------------
-- Objective 2: Raid Koritsa before capturing Mt. Olympus --
------------------------------------------------------------

-- ** Condition for OnObjective2() **
function Objective2Condition(action)
	return action.side == 0 and action.objective == 2 and action.status == ObjectiveStatus.Success
end

-- ** 1x Effect(ObjectiveStatusAction) {if Objective2Condition()} **
function OnObjective2(action)
	local comm = 2
	campaign.comm_points = lib.UpdateCommendationPoints(comm)
	MessageBox(string.format(tostring(NSLOCTEXT("scenario_Thessaloniki","earned_cp_format2","Bonus Objective to raid Koritsa completed.\nEarned Commendation Points: %d.\nTotal Commendation Points: %d.")), comm, campaign.comm_points))
end
