-- Players:
	-- 0 [H]:	Germany
	-- 1 [AI]:	USSR
p_RU=1

-- 2 Objectives defined in scenario:
	-- 0 		Capture all victory hexes
	-- 1 opt	Unit must survive	unit ID 5	-- Wagner

-- 2 Triggers defined in scenario:
	-- 1x	EnemyHero(NewRoundAction)
	-- 1x	OnVictory(VictoryAction)	-- Wagner

-- Use lib. prefix for utility and support functions:
lib = require "shared"	-- file shared.lua in campaign directory ../AO1941East

-- ** called automatically **
function OnMapStart()
	local value = campaign.comm_points or 0
	campaign.comm_points = lib.InitCommendationPoints(value)	-- UI: Commendation Points
end

--------------
-- Triggers --
--------------

------------------
-- Enemy heroes --
------------------

enemy_heroes = {
	-- @NOTE: name not provided (pick up from unit.name, if any)
	{unit_id=46, traits={UnitTrait.LowProfile, UnitTrait.OverwhelmingAttack}},		-- tank S of Dovsk, per scenario
	{unit_id=10, traits={UnitTrait.CounterBattery, UnitTrait.DoubleAttack}},		-- art in E Gomel, per scenario
	{unit_id=31, traits={UnitTrait.IncMaxOverstrength, UnitTrait.FierceFighter}},	-- rcn WSW of Gomel, per scenario
	{unit_id= 8, traits={UnitTrait.FerociousDefense, UnitTrait.PreciseOptics}}		-- inf eng in Gomel, per scenario
}

-- ** 1x Effect(NewRoundAction) **
-- Creates enemy Hero(es)
function EnemyHero()
	lib.CreateAndAssignHeroes(p_RU, enemy_heroes)
end

-- @NOTE: a Wagner Hero is not created/assigned in this scenario

---------------------------------------------------------
-- Objective 1: Wagner's Halftrack Survives the Battle --
---------------------------------------------------------

-- ** Condition for OnObjective1() **
function Objective1Condition(action)
	return action.side == 0 and action.objective == 1 and action.status == ObjectiveStatus.Success
end

-- ** 1x Effect(ObjectiveStatusAction) {if Objective1Condition()} **
function OnObjective1(action)
	local comm = 1
	campaign.comm_points = lib.UpdateCommendationPoints(comm)
	MessageBox(string.format(tostring(NSLOCTEXT("scenario_Gomel","earned_cp_format","Bonus Objective for Wagner's Halftrack surviving completed.\nEarned Commendation Points: %d.\nTotal Commendation Points: %d.")), comm, campaign.comm_points))
end

-- @TODO: .lib
function GetObjectiveStatus(side, objective)	-- support function: returns enum ObjectiveStatus (.Success|.Fail) of the given side's objective
	return world.sides[side+1].objectives[objective+1].status
end

-- ** 1x Effect(VictoryAction) **
-- ** checked at scenario end **
function OnVictory()
	if (GetObjectiveStatus(0,1) == ObjectiveStatus.Fail) then return end

	local comm = 1
	campaign.comm_points = lib.UpdateCommendationPoints(comm)
-- @FIXME: duplicated from OnObjective1(), above:
	MessageBox(string.format(tostring(NSLOCTEXT("scenario_Gomel","earned_cp_format","Bonus Objective for Wagner's Halftrack surviving completed.\nEarned Commendation Points: %d.\nTotal Commendation Points: %d.")), comm, campaign.comm_points))
end
