-- Players:
	-- 0 [H]:	Germany
	-- 1 [AI]:	USSR
p_RU=1
	-- 2 [AI]:	Germany - 1st Panzer
p_1div=2

-- 2 Objectives defined in scenario:
	-- 0 @end	Capture 11 victory hexes	(12;2)(15;2)(16;4)(19;4)(21;6)(23;8)(24;9)(24;12)(23;15)(23;22)(27;28)
	-- 1 opt	Capture 6 victory hexes		(8;12)(4;13)(6;13)(7;15)(6;16)(9;16)	-- Kiev

-- 3 Triggers defined in scenario:
	-- 1x	EnemyHero(NewRoundAction)
	-- 1x	OnObjective1(CaptureFlagAction)	{if Objective1Condition()}
	-- 1x	EndSalvage(NewRoundAction)		{if TurnTwenty()}

-- Use lib. prefix for utility and support functions:
lib = require "shared"	-- file shared.lua in campaign directory ../AO1941East

-- ** called automatically **
function OnMapStart()
	local value = campaign.comm_points or 0
	campaign.comm_points = lib.InitCommendationPoints(value)	-- UI: Commendation Points
end

--------------
-- Triggers --
--------------

------------------
-- Enemy heroes --
------------------

enemy_heroes = {
	-- @NOTE: name not provided (pick up from unit.name, if any)
	{unit_id= 73, traits={UnitTrait.NoSupply, UnitTrait.AimingAssistance}},	-- tank C of Kiev, per scenario
	{unit_id=107, traits={UnitTrait.IgnoresZOC, UnitTrait.MachineGun}},	-- inf NE of Kiev, per scenario
	{unit_id=100, traits={UnitTrait.FlagKiller, UnitTrait.DoubleAttack, UnitTrait.LightningAttack}},	-- art SE of Kiev, per scenario
	{unit_id= 75, traits={UnitTrait.NoSupply, UnitTrait.Provocator}} 	-- tank C of Kiev, per scenario
}

-- ** 1x Effect(NewRoundAction) **
-- Creates enemy Hero(es)
function EnemyHero()
	lib.CreateAndAssignHeroes(p_RU, enemy_heroes)
end

-----------------------------------------
-- Objective 1: Capture all Kiev Hexes --
-----------------------------------------

-- ** Condition for OnObjective1() **
function Objective1Condition(action)
	return action.side == 0 and action.objective == 1 and action.status == ObjectiveStatus.Success
end

-- ** 1x Effect(ObjectiveStatusAction) {if Objective1Condition()} **
function OnObjective1(action)
	local comm = 5
	campaign.comm_points = lib.UpdateCommendationPoints(comm)
	MessageBox(string.format(tostring(NSLOCTEXT("scenario_Kiev1941","earned_cp_format","Bonus Objective to Capture all Kiev Hexes completed.\nEarned Commendation Points: %d.\nTotal Commendation Points: %d.")), comm, campaign.comm_points))
end

----------------------
-- CP for equipment --
----------------------

trade = {
	cps = 4,
	eqs = {{"KV1-40",19},{"BM13Katyusha",18},{"MiG3",29},{"PetlyakovPe2",26}}
}

-- ** Condition for EndSalvage() **
function TurnTwenty()
	return world.round == 20
end

-- ** 1x Effect(NewRoundAction) {if TurnTwenty()} **
function EndSalvage()
	if (campaign.comm_points < trade.cps) then return end

	local message = string.format(tostring(NSLOCTEXT("scenario_Kiev1941","difficult_choice2","Mein General, excuse the interruption, but an urgent report arrived.  Our salvage teams want to know what to do with the vast stockpiles of Soviet equipment we have seized.  Should I tell them to take the time and resources to return it to working order, or just abandon it all?\n\nYou have %d Commendation Points.\n\nWould you like to use 4 Commendation Points acquire a collection of captured Soviet vehicles and aircraft?")), campaign.comm_points)
	local choose_action = world:MakeChooseAction(0, message, "ProcessChoice")
	choose_action.options = {
		{
			title  = NSLOCTEXT("scenario_Kiev1941","option1","Authorize the exchange"),
			tooltip= NSLOCTEXT("scenario_Kiev1941","option1_tooltip","")
		},
		{
			title  = NSLOCTEXT("scenario_Kiev1941","option2","Decline the exchange"),
			tooltip= NSLOCTEXT("scenario_Kiev1941","option2_tooltip","")
		}
	}
	world:Exec(choose_action)	-- "ProcessChoice" ==> ProcessChoice(player,choice)
end

function ProcessChoice(player, choice)
	if (choice == 1) then		-- The player chose option 1, which is "yes"
		local comm = 0 - trade.cps	-- make negative
		campaign.comm_points = lib.UpdateCommendationPoints(comm)
		lib.AddEquipments(player, trade.eqs, Captured)
	end
	local choice_made =
	{
		NSLOCTEXT("scenario_Kiev1941","choice_made1","You choose to accept the offer.  You now have %d Commendation Points."),
		NSLOCTEXT("scenario_Kiev1941","choice_made2","You choose to reject the offer.  You still have %d Commendation Points"),
	}
	MessageBox(string.format(tostring(choice_made[choice]), campaign.comm_points))
end
