-- Players:
	-- 0 [H]:	Germany
	-- 1 [AI]:	USSR
p_RU=1

-- 2 Objectives defined in scenario:
	-- 0 @end	Capture 4 victory hexes		(9;3)(16;3)(18;4)(3;6)(28;6)(20;13)(12;18)(13;21)(23;24)
	-- 1 opt	Capture all victory hexes

-- 3 Triggers defined in scenario:
	-- 1x	AxisMinor(NewRoundAction)
	-- 1x	EnemyHero(NewRoundAction)
	-- 1x	OnObjective1(CaptureFlagAction)	{if Objective1Condition()}

-- Use lib. prefix for utility and support functions:
lib = require "shared"	-- file shared.lua in campaign directory ../AO1941East

-- ** called automatically **
function OnMapStart()
	local value = campaign.comm_points or 0
	campaign.comm_points = lib.InitCommendationPoints(value)	-- UI: Commendation Points
end

--------------
-- Triggers --
--------------

------------------
-- Enemy heroes --
------------------

enemy_heroes = {
	-- @NOTE: name not provided (pick up from unit.name, if any)
	{unit_id= 8, traits={UnitTrait.Camouflage, UnitTrait.TankKiller}},			-- at NW of Kaluga, per scenario
	{unit_id=13, traits={UnitTrait.LightningAttack}},							-- art E Mozhaisk, per scenario
	{unit_id=21, traits={UnitTrait.LastStand}},									-- inf in Maloyaroslavets, per scenario
	{unit_id=74, traits={UnitTrait.ExpertRecon, UnitTrait.CripplingBlow}},		-- tank in ent lines NE of Yukhnov, per scenario
	{unit_id=95, traits={UnitTrait.FastRetreat, UnitTrait.SuperiorManeuver}} 	-- tank near NE Nara R obj, per scenario
}

-- ** 1x Effect(NewRoundAction) **
-- Creates enemy Hero(es)
function EnemyHero()
	lib.CreateAndAssignHeroes(p_RU, enemy_heroes)
end

-------------------
-- Prestige dump --
-------------------

eqs = {{"L6-40Lf",35},{"M14-41",35},{"38MToldiI",35}}

-- ** 1x Effect(NewRoundAction) **
function AxisMinor()
	local message = string.format(tostring(NSLOCTEXT("scenario_MozhaiskLine","difficult_choiceAxisMinor","Herr General, we have received another special offer from our allies.  The Italians and Hungarians are back with another offer to replenish our limited stockpile of their tanks.  The Italians are offering some more light flame tanks and medium tanks while the Hungarians have even more of their Toldi tanks up for trade.\n\nThey are asking for what will amount to half of our supply stockpile in exchange though, which might bite even further into our already meager resources.\n\nCan we afford to exchange half of our supplies for another collection of Italian and Hungarian tanks?")))
	local choose_action = world:MakeChooseAction(0, message, "ProcessChoice")
	choose_action.options = {
		{
			title  = NSLOCTEXT("scenario_MozhaiskLine","option1AxisMinor","Accept the offer"),
			tooltip= NSLOCTEXT("scenario_MozhaiskLine","option1_tooltip","")
		},
		{
			title  = NSLOCTEXT("scenario_MozhaiskLine","option2AxisMinor","Reject the offer"),
			tooltip= NSLOCTEXT("scenario_MozhaiskLine","option2_tooltip","")
		}
	}
	world:Exec(choose_action)	-- "ProcessChoice" ==> ProcessChoice(player,choice)
end

function ProcessChoice(player, choice)
	if (choice == 1) then		-- The player chose option 1, which is "yes"
		lib.AddEquipments(player, eqs, Captured)

		local p = world:GetPlayer(player)
		p.prestige = math.ceil(p.prestige / 2)  -- remove 50% of prestige
	end

	local choice_madeAxisMinor =
	{
		NSLOCTEXT("scenario_MozhaiskLine","choice_made9","You accept the offer at a cost of half of your supplies."),
		NSLOCTEXT("scenario_MozhaiskLine","choice_made10","You decline the offer."),
	}
	MessageBox(string.format(tostring(choice_madeAxisMinor[choice])))
end

----------------------------------------------
-- Objective 1: Capture all 9 Victory Hexes --
----------------------------------------------

-- ** Condition for OnObjective1() **
function Objective1Condition(action)
	return action.side == 0 and action.objective == 1 and action.status == ObjectiveStatus.Success
end

-- ** 1x Effect(ObjectiveStatusAction) {if Objective1Condition()} **
function OnObjective1(action)
	local comm = 3
	campaign.comm_points = lib.UpdateCommendationPoints(comm)
	MessageBox(string.format(tostring(NSLOCTEXT("scenario_MozhaiskLine","earned_cp_format","Bonus Objective to Capture all 9 Victory Hexes completed.\nEarned Commendation Points: %d.\nTotal Commendation Points: %d.")), comm, campaign.comm_points))
end
